moMouseKeyEventsLightSetting = {};

function moMouseKeyEventsLightSetting:setMouse(posX, posY, isDown, isUp, button, clickAreaTable)
	if button == Input.MOUSE_BUTTON_LEFT then
		moMouseKeyEventsLightSetting:buttonLeft(posX, posY, isDown, isUp, button, clickAreaTable);
	elseif button == Input.MOUSE_BUTTON_MIDDLE then
		moMouseKeyEventsLightSetting:buttonMiddle(posX, posY, isDown, isUp, button, clickAreaTable);
	elseif button == Input.MOUSE_BUTTON_RIGHT then
		moMouseKeyEventsLightSetting:buttonRight(posX, posY, isDown, isUp, button, clickAreaTable);
	elseif button == Input.MOUSE_BUTTON_WHEEL_UP then
		moMouseKeyEventsLightSetting:buttonWheelUp(posX, posY, isDown, isUp, button, clickAreaTable);
	elseif button == Input.MOUSE_BUTTON_WHEEL_DOWN then
		moMouseKeyEventsLightSetting:buttonWheelDown(posX, posY, isDown, isUp, button, clickAreaTable);
	end;		
end;

function moMouseKeyEventsLightSetting:buttonLeft(posX, posY, isDown, isUp, button, clickAreaTable)
	if clickAreaTable.whereClick == "buttonClose_" and isDown then
		moSetGetOverlaysLight.default.setting.on = false;moSetGetOverlaysLight.default.setting.typ = "";moSetGetOverlaysLight.default.setting.selectApp =0;
		local infoTxt = "Tipp: PDA Type Light\n1. Up/Down Scroll in PDA is view Apps > minViewApps\n2. Click all Pda Icons Left/Middle/Right Mouse (if deposited)"
		g_currentMission.hl.addTextDisplay( {txt=infoTxt, maxLine=3, txtBold=true, duration=7} );
		return;
	elseif clickAreaTable.whereClick == "buttonSave_" and isDown then
		if not moGeneralSettings.isSave then moXmlSettings:saveXml();end;
		return;
	elseif clickAreaTable.whereClick == "buttonDelete_" and isDown then
		if moSetGetOverlaysLight.default.setting.selectPda == 1 then return;end;
		if moSetGetOverlaysLight.default.pda[moSetGetOverlaysLight.default.setting.selectPda] ~= nil then
			guiDialog:deleteSlavePdaTypeLight(moSetGetOverlaysLight.default.setting.selectPda);
		end;
		return;	
	elseif clickAreaTable.whereClick == "appIcon_" and isDown then	
		if moSetGetOverlaysLight.default.setting.selectApp == clickAreaTable.app then 
			moSetGetOverlaysLight.default.setting.selectApp = 0;			
		else 			
			local pdaTable = moSetGetOverlaysLight.default.pda[moSetGetOverlaysLight.default.setting.selectPda];			
			if pdaTable ~= nil and pdaTable.app ~= nil and pdaTable.app[clickAreaTable.app] ~= nil then
				moSetGetOverlaysLight.default.setting.selectApp = clickAreaTable.app;
				local maxLine = 3
				local infoTxt = "This Icon ";
				if pdaTable.app[clickAreaTable.app].typ == "slot" or pdaTable.app[clickAreaTable.app].typ == "pda" then
					infoTxt = infoTxt.. "Open/Close a ".. tostring(pdaTable.app[clickAreaTable.app].typ:upper()).. "\nif unavailable ! then generate new ".. tostring(pdaTable.app[clickAreaTable.app].typ:upper()).. " and set a cmds (if deposited)\nName: ".. tostring(pdaTable.app[clickAreaTable.app].name);
				else
					local cmdName = "CMD: not found ".. tostring(pdaTable.app[clickAreaTable.app].name);
					if MultiOverlayV4.cmd[pdaTable.app[clickAreaTable.app].name] ~= nil then cmdName = "CMD: ".. tostring(MultiOverlayV4.cmd[pdaTable.app[clickAreaTable.app].name].displayName);end;
					if pdaTable.app[clickAreaTable.app].iconText ~= nil and pdaTable.app[clickAreaTable.app].iconText.onDraw ~= nil then
						infoTxt = infoTxt.. "execute command (>_)\nif found cmd and onDraw Action ! then set + onDraw Action\n".. cmdName;
					else
						infoTxt = infoTxt.. "execute command (>_)\n".. cmdName;
						maxLine = 2;
					end;
				end;
				g_currentMission.hl.addTextDisplay( {txt=infoTxt, maxLine=maxLine, txtBold=true, duration=15} );
			else
				moSetGetOverlaysLight.default.setting.selectApp = 0;
				g_currentMission.hl.addTextDisplay( {txt="!! Upps something went wrong !!", txtBold=true, duration=5, warning=true} );
			end;
		end;		
	elseif clickAreaTable.whereClick == "appView_" and isDown then		
		local pdaTable = moSetGetOverlaysLight.default.pda[moSetGetOverlaysLight.default.setting.selectPda];
		if pdaTable ~= nil and pdaTable.app ~= nil and pdaTable.app[clickAreaTable.app] ~= nil then
			pdaTable.app[clickAreaTable.app].view = not pdaTable.app[clickAreaTable.app].view;			
			moSetGetLight:setPdaBounds(moSetGetOverlaysLight.default.setting.selectPda);			
			if not pdaTable.app[clickAreaTable.app].view then
				g_currentMission.hl.addTextDisplay( {txt="View AppIcon OFF", txtColor="yellow", txtBold=true, duration=3} );			
			else				
				local typTxt = "AppIcon Typ is open a ".. tostring(pdaTable.app[clickAreaTable.app].typ:upper());
				local name = tostring(pdaTable.app[clickAreaTable.app].typ:upper()).. ": ".. tostring(pdaTable.app[clickAreaTable.app].name);				
				local info = "Icon Color State:";
				local colorInfo = "White--> *ready* / Ls22--> *open* / Gray--> *not ready*";
				local notReadyInfo = "State: *not ready*--> Auto Generate Pda/Slot(+cmds, if deposited)"
				g_currentMission.hl.addTextDisplay( {txt="View AppIcon ON\n".. typTxt.. "\n".. name.. "\n".. info.. "\n".. colorInfo.. "\n".. notReadyInfo, maxLine=6, txtBold=true, duration=10} );
			end;
			MultiOverlayV4:setUnSave();
		end;
		return;
	elseif clickAreaTable.whereClick == "appInfoBar_" and isDown then
		local pdaTable = moSetGetOverlaysLight.default.pda[moSetGetOverlaysLight.default.setting.selectPda];
		if pdaTable ~= nil and pdaTable.app ~= nil and pdaTable.app[clickAreaTable.app] ~= nil then
			if pdaTable.app[clickAreaTable.app].typ == "slot" and pdaTable.app[clickAreaTable.app].infoBar ~= nil and pdaTable.app[clickAreaTable.app].infoBar.view ~= nil then
				pdaTable.app[clickAreaTable.app].infoBar.view = not pdaTable.app[clickAreaTable.app].infoBar.view;
				if not pdaTable.app[clickAreaTable.app].infoBar.view then
					pdaTable.app[clickAreaTable.app].infoBar.textTicker = false;
					g_currentMission.hl.addTextDisplay( {txt="View AppIcon InfoBar OFF", txtColor="yellow", txtBold=true, duration=5} );
				else
					local timerTxt = "Update all ! depending on Module or Mod";
					local noticeTxt = "see Notice InfoIcon, have a Problem or... and NOT OPEN or Active...";
					g_currentMission.hl.addTextDisplay( {txt="View AppIcon InfoBar ON\n".. timerTxt.. "\n".. noticeTxt, maxLine=3, txtBold=true, duration=10} );
				end;
				MultiOverlayV4:setUnSave();
			else
				g_currentMission.hl.addTextDisplay( {txt="AppInfoBar not implements for this Slot/Pda/Cmd Icon", txtBold=true, duration=5, warning=true} );
			end;
		end;
	elseif clickAreaTable.whereClick == "appTextTicker_" and isDown then
		local pdaTable = moSetGetOverlaysLight.default.pda[moSetGetOverlaysLight.default.setting.selectPda];
		if pdaTable ~= nil and pdaTable.app ~= nil and pdaTable.app[clickAreaTable.app] ~= nil then
			if moGeneralSettings.textTicker.isOn then
				if pdaTable.app[clickAreaTable.app].typ == "slot" and pdaTable.app[clickAreaTable.app].textTicker ~= nil and pdaTable.app[clickAreaTable.app].textTicker.view ~= nil then					
					pdaTable.app[clickAreaTable.app].textTicker.view = not pdaTable.app[clickAreaTable.app].textTicker.view;
					if not pdaTable.app[clickAreaTable.app].textTicker.view then
						g_currentMission.hl.addTextDisplay( {txt="View App Text Ticker OFF", txtColor="yellow", txtBold=true, duration=5} );
					else
						local timerTxt = "Update all ! depending on Mod";
						local noticeTxt = "see Info Text, have a Problem or... (Option Testing...)";
						local optional = "Set Optional other Position (MultiOverlayV4 Menue / Globas Setting)"
						g_currentMission.hl.addTextDisplay( {txt="View App Text Ticker ON\n".. timerTxt.. "\n".. noticeTxt.. "\n".. optional, maxLine=4, txtBold=true, duration=10} );
					end;
					MultiOverlayV4:setUnSave();					
				else
					g_currentMission.hl.addTextDisplay( {txt="App Text Ticker not implements for this Slot/Pda/Cmd Icon", txtBold=true, duration=5, warning=true} );
				end;
			else
				local info = "--> MultiOverlayV4 Menue / Global Settings"
				g_currentMission.hl.addTextDisplay( {txt="Text Ticker is Disabled (Global value)\n".. info, maxLine=2, txtBold=true, duration=5, warning=true} );
			end;
		end;
	elseif clickAreaTable.whereClick == "appLeftRight_" and isDown then		
		local isNewPos = moSetGetLight:setNewAppOrder(false);
		if isNewPos then
			local infoTxt = "Click Mouse Button Left or Right";
			g_currentMission.hl.addTextDisplay( {txt="<--- Set AppIcon new position\n".. infoTxt, maxLine=2, txtBold=true, duration=10} );
			MultiOverlayV4:setUnSave();
		else
			g_currentMission.hl.addTextDisplay( {txt="!! Upps something went wrong !!", txtBold=true, duration=5, warning=true} );
		end;
	elseif clickAreaTable.whereClick == "appAutoClose_" and isDown then
		local pdaTable = moSetGetOverlaysLight.default.pda[moSetGetOverlaysLight.default.setting.selectPda];
		if pdaTable ~= nil and pdaTable.app ~= nil and pdaTable.app[clickAreaTable.app] ~= nil then
			pdaTable.app[clickAreaTable.app].autoClose = not pdaTable.app[clickAreaTable.app].autoClose;
			if pdaTable.app[clickAreaTable.app].typ ~= "cmd" then
				if not pdaTable.app[clickAreaTable.app].autoClose then
					local infoTxt = "This ".. tostring(pdaTable.app[clickAreaTable.app].typ:upper()).. " not Close if other ".. tostring(pdaTable.app[clickAreaTable.app].typ:upper()).. " open Click";
					local infoTxt1 = "ONLY FOR THIS PDA";
					g_currentMission.hl.addTextDisplay( {txt="Set this AppIcon AutoClose OFF\n".. infoTxt.. "\n".. infoTxt1, maxLine=3, txtColor="yellow", txtBold=true, duration=10} );
				else
					local infoTxt = "This ".. tostring(pdaTable.app[clickAreaTable.app].typ:upper()).. " close if other ".. tostring(pdaTable.app[clickAreaTable.app].typ:upper()).. " open Click";
					local infoTxt1 = "ONLY FOR THIS PDA";
					g_currentMission.hl.addTextDisplay( {txt="Set this AppIcon AutoClose ON\n".. infoTxt.. "\n".. infoTxt1, maxLine=3, txtBold=true, duration=10} );
				end;
				MultiOverlayV4:setUnSave();
			else
				g_currentMission.hl.addTextDisplay( {txt="Only AutoClose for Slot/Pda Icon", txtBold=true, duration=5, warning=true} );
			end;
		end;
	elseif clickAreaTable.whereClick == "autoWidthOnOff_" and isDown then
		local pdaTable = moSetGetOverlaysLight.default.pda[moSetGetOverlaysLight.default.setting.selectPda];
		if pdaTable ~= nil then
			if moSetGetOverlaysLight.default.setting.selectPda == 1 then
				pdaTable.autoWidth = not pdaTable.autoWidth;
				moSetGetLight:setPdaBounds(moSetGetOverlaysLight.default.setting.selectPda);
				if pdaTable.autoWidth then
					local infoTxt = "View turned on AppIcons by LS WTM Hud Width (view min ".. tostring(pdaTable.minViewApps).. ")";
					local infoTxt1 = "Optional Scroll Up/Down with Mouse in PDA";
					g_currentMission.hl.addTextDisplay( {txt="Set Auto Width ON\n".. infoTxt.. "\n".. infoTxt1, maxLine=3, txtColor="yellow", txtBold=true, duration=10} );
				else
					local infoTxt = "View max turned on AppIcons";
					g_currentMission.hl.addTextDisplay( {txt="Set Auto Width OFF\n".. infoTxt, maxLine=2, txtColor="yellow", txtBold=true, duration=10} );
				end;
				MultiOverlayV4:setUnSave();
			else
				g_currentMission.hl.addTextDisplay( {txt="Only for Master PDA", txtBold=true, duration=5, warning=true} );
			end;
		end;
	elseif clickAreaTable.whereClick == "minViewApps_" and isDown then
		local pdaTable = moSetGetOverlaysLight.default.pda[moSetGetOverlaysLight.default.setting.selectPda];
		if pdaTable ~= nil then
			local infoTxt = "NEEDS Auto Width OFF";
			if not pdaTable.autoWidth then
				if pdaTable.minViewApps >= pdaTable.maxViewApps then 
					pdaTable.minViewApps = moSetGetOverlaysLight.default.limitMinViewApps;
				else
					pdaTable.minViewApps = pdaTable.minViewApps+1;
				end;
				g_currentMission.hl.addTextDisplay( {txt="Set Min. View Apps ".. tostring(pdaTable.minViewApps), maxLine=1, txtColor="yellow", txtBold=true, duration=10} );
				if moSetGetOverlaysLight.default.setting.selectPda ~= 1 then moSetGetOverlaysLight:updateSlavePdas(true);end;
				moSetGetLight:setPdaBounds(moSetGetOverlaysLight.default.setting.selectPda);
				MultiOverlayV4:setUnSave();
			else
				g_currentMission.hl.addTextDisplay( {txt=infoTxt, maxLine=1, txtBold=true, duration=5, warning=true} );
			end;
		end;		
	elseif clickAreaTable.whereClick == "keyControl_" and isDown then
		g_currentMission.hl.addTextDisplay( {txt="Light PDA Key Control not ready/wait update", txtBold=true, duration=3, warning=true} );
	end;
end;

function moMouseKeyEventsLightSetting:buttonMiddle(posX, posY, isDown, isUp, button, clickAreaTable)
	
end;

function moMouseKeyEventsLightSetting:buttonRight(posX, posY, isDown, isUp, button, clickAreaTable)
	if clickAreaTable.whereClick == "buttonSetting_" and isDown then		
		--g_currentMission.hl.addTextDisplay( {txt="click buttonSetting rightMouse", txtBold=true, duration=3} );
	elseif clickAreaTable.whereClick == "appLeftRight_" and isDown then
		local isNewPos = moSetGetLight:setNewAppOrder(true);
		if isNewPos then
			local infoTxt = "Click Mouse Button Left or Right";
			g_currentMission.hl.addTextDisplay( {txt="---> Set AppIcon new position\n".. infoTxt, maxLine=2, txtBold=true, duration=10} );
			MultiOverlayV4:setUnSave();
		else
			g_currentMission.hl.addTextDisplay( {txt="!! Upps something went wrong !!", txtBold=true, duration=5, warning=true} );
		end;
	elseif clickAreaTable.whereClick == "minViewApps_" and isDown then
		local pdaTable = moSetGetOverlaysLight.default.pda[moSetGetOverlaysLight.default.setting.selectPda];
		if pdaTable ~= nil then
			local infoTxt = "NEEDS Auto Width OFF";
			if not pdaTable.autoWidth then
				if pdaTable.minViewApps <= moSetGetOverlaysLight.default.limitMinViewApps then 
					pdaTable.minViewApps = pdaTable.maxViewApps or 20;
				else
					pdaTable.minViewApps = pdaTable.minViewApps-1;
				end;
				g_currentMission.hl.addTextDisplay( {txt="Set Min. View Apps ".. tostring(pdaTable.minViewApps), maxLine=1, txtColor="yellow", txtBold=true, duration=10} );
				if moSetGetOverlaysLight.default.setting.selectPda ~= 1 then moSetGetOverlaysLight:updateSlavePdas(true);end;
				moSetGetLight:setPdaBounds(moSetGetOverlaysLight.default.setting.selectPda);
				MultiOverlayV4:setUnSave();
			else
				g_currentMission.hl.addTextDisplay( {txt=infoTxt, maxLine=1, txtBold=true, duration=5, warning=true} );
			end;			
		end;
	elseif clickAreaTable.whereClick == "keyControl_" and isDown then
		g_currentMission.hl.addTextDisplay( {txt="Light PDA Key Control not ready/wait update", txtBold=true, duration=3, warning=true} );	
	end;
end;

function moMouseKeyEventsLightSetting:buttonWheelUp(posX, posY, isDown, isUp, button, clickAreaTable)
	
end;

function moMouseKeyEventsLightSetting:buttonWheelDown(posX, posY, isDown, isUp, button, clickAreaTable)
	
end;
