moDraw.iconText = {};

function moDraw.iconText:setPda(overlay, app, optiHeightSize, txtColor, isInArea)
	if app == nil or app.iconText == nil or app.iconText.onDraw == nil or type(app.iconText.onDraw) ~= "function"  then return;end;
	app.iconText.onDraw( {overlay=overlay, infoBarState=app.infoBar ~= nil and app.infoBar.view ~= nil and app.infoBar.view, app=app, optiHeightSize=optiHeightSize, txtColor=txtColor, isInArea=isInArea} );
end;

function moDraw.iconText.setPdaTxt(args)
	if args == nil or type(args) ~= "table" then return;end;
	if args.infoBarState then return;end;
	local txt = tostring(args.app.typ:upper());		
	if args.app.typ == "cmd" then
		if args.app.name == "MultiOverlayV4_cmd_action_handToolsSwitch_" then
			if not moGeneralSettings.other.handToolsSwitch then txt = "OFF";
				if not args.isInArea then args.txtColor = g_currentMission.hl.getColor(moSetGetOverlaysLight.default.iconColor.open, true);end;
			end;
		end;	
	end;		
	--optiHeightSize = g_currentMission.hl.optiWidthSize(args.overlay.width, txt, args.optiHeightSize-0.004)
	local txtWidth = getTextWidth(args.optiHeightSize-0.0035, utf8Substr(txt, 0));	
	setTextBold(true);	
	setTextColor(unpack(args.txtColor));
	renderText(args.overlay.x+(args.overlay.width/2)-(txtWidth/2), args.overlay.y+args.overlay.height-0.002, args.optiHeightSize-0.0035, txt);	
end;