moSetGetOverlaysLight = {};
source(MultiOverlayV4.modDir.."scripte/overlays/light/moSetGetLight.lua");
source(MultiOverlayV4.modDir.."scripte/draw/light/moDrawLight.lua");

moSetGetOverlaysLight.default = {	
	keyInteraction = false;
	setting = {icon={},maxAppWidth=15,isOn=false,typ="",selectApp=0, selectPda=1};
	limitMaxViewApps = 20;
	limitMinViewApps = 2; --not edit
	iconColor = {select="ls15",selectInactive="whiteInactive",inactive="whiteOff",default="white",open="ls22",infoBar="whiteOff",notice="warningRed",disabled="red",enabled="green"};
	iconHeight = 0; --moSetGetOverlays.buttonGfxHeight1*25;
	iconWidth = 0; --moSetGetOverlays.buttonGfxWidth1*25;
	appHeight = 0; --(moSetGetOverlays.buttonGfxHeight1*25)*2;
	appWidth = 0; --(moSetGetOverlays.buttonGfxWidth1*25)*2;
	optiHeightSize = 0; --g_currentMission.hl.optiHeightSize(moSetGetOverlays.buttonGfxHeight1*25, "Ä", 0.015);
	lastSwitchSlot = ""; --for Cmd switchSlots
	lastSwitchPda = ""; --for Cmd switchPdas
	selectPda = 1; --for keyControl
	selectApp = 1; --for keyControl
	pdaDefault = {
		name = "";
		view = {true,false}; --view / smallView --free
		minViewApps=2; --not edit
		maxViewApps=20;
		autoWidth=true;
		bounds={isLine=1,line={},lineMax=1,maxViewApps=0,viewApps=0};		
		selectApp=1;
		otherIcons = 2;
		distancePda = 4; --..../distancePda
		appOrder = {};
		app = {
			{iconName="fillTypeAmountPrice",intern=true,view=true,name="fillTypeAmountPriceSlot_",typ="slot",autoClose=true,onAction=moSetGetLight.onActionSlot, onDrawColorState=moSetGetLight.onDrawColorStateSlotPda};
			{iconName="mapMissions",intern=true,view=true,name="mapMissionsSlot_",typ="slot",autoClose=true,textTicker={view=true,onDraw=moMissions.setTextTicker},infoBar={view=true,onDraw=moMissions.setInfoBar}, onAction=moSetGetLight.onActionSlot, onDrawColorState=moSetGetLight.onDrawColorStateSlotPda};
			{iconName="mapFarmlands",intern=true,view=true,name="mapFarmlandsSlot_",typ="slot",autoClose=true, onAction=moSetGetLight.onActionSlot, onDrawColorState=moSetGetLight.onDrawColorStateSlotPda};
			{iconName="animalsPda",intern=true,view=true,name="animalsPda_",typ="pda",autoClose=true, iconText={onDraw=moDraw.iconText.setPdaTxt}, onAction=moSetGetLight.onActionPda, onDrawColorState=moSetGetLight.onDrawColorStateSlotPda};
			{iconName="productionsPda",intern=true,view=true,name="productionsPda_",typ="pda",autoClose=true, iconText={onDraw=moDraw.iconText.setPdaTxt}, onAction=moSetGetLight.onActionPda, onDrawColorState=moSetGetLight.onDrawColorStateSlotPda};
			{iconName="greenhouse1",intern=true,view=true,name="greenhouse1Slot_",typ="slot",autoClose=true, onAction=moSetGetLight.onActionSlot, onDrawColorState=moSetGetLight.onDrawColorStateSlotPda};
			{iconName="factorys1",intern=true,view=true,name="factorys1Slot_",typ="slot",autoClose=true, onAction=moSetGetLight.onActionSlot, onDrawColorState=moSetGetLight.onDrawColorStateSlotPda};
			{iconName="bgas",intern=true,view=true,name="bgasSlot_",typ="slot",autoClose=true, onAction=moSetGetLight.onActionSlot, onDrawColorState=moSetGetLight.onDrawColorStateSlotPda};
			{iconName="bunkerSilos",intern=true,view=false,name="bunkerSilosSlot_",typ="slot",autoClose=true, onAction=moSetGetLight.onActionSlot, onDrawColorState=moSetGetLight.onDrawColorStateSlotPda};
			{iconName="buyingSellingStations",intern=true,view=true,name="buyingSellingStationsSlot_",typ="slot",autoClose=true, onAction=moSetGetLight.onActionSlot, onDrawColorState=moSetGetLight.onDrawColorStateSlotPda};
			{iconName="others1",intern=true,view=true,name="others1Slot_",typ="slot",autoClose=true, onAction=moSetGetLight.onActionSlot, onDrawColorState=moSetGetLight.onDrawColorStateSlotPda};				
			{iconName="factorys2",intern=true,view=false,name="factorys2Slot_",typ="slot",autoClose=true, onAction=moSetGetLight.onActionSlot, onDrawColorState=moSetGetLight.onDrawColorStateSlotPda};
			{iconName="factorys3",intern=true,view=false,name="factorys3Slot_",typ="slot",autoClose=true, onAction=moSetGetLight.onActionSlot, onDrawColorState=moSetGetLight.onDrawColorStateSlotPda};
			{iconName="greenhouse2",intern=true,view=false,name="greenhouse2Slot_",typ="slot",autoClose=true, onAction=moSetGetLight.onActionSlot, onDrawColorState=moSetGetLight.onDrawColorStateSlotPda};
			{iconName="greenhouse3",intern=true,view=false,name="greenhouse3Slot_",typ="slot",autoClose=true, onAction=moSetGetLight.onActionSlot, onDrawColorState=moSetGetLight.onDrawColorStateSlotPda};
			{iconName="vehicleState",intern=true,view=true,name="vehicleStateSlot_",typ="slot",autoClose=true, onAction=moSetGetLight.onActionSlot, onDrawColorState=moSetGetLight.onDrawColorStateSlotPda};
			{iconName="vehiclePda",intern=true,view=false,name="vehiclePda_",typ="pda",autoClose=true, iconText={onDraw=moDraw.iconText.setPdaTxt}, onAction=moSetGetLight.onActionPda, onDrawColorState=moSetGetLight.onDrawColorStateSlotPda};
			{iconName="productionInfo",intern=true,view=false,name="productionInfoSlot_",typ="slot",autoClose=true, onAction=moSetGetLight.onActionSlot, onDrawColorState=moSetGetLight.onDrawColorStateSlotPda};
			{iconName="teleportPoints",intern=true,view=false,name="teleportPointsSlot_",typ="slot",autoClose=true, onAction=moSetGetLight.onActionSlot, onDrawColorState=moSetGetLight.onDrawColorStateSlotPda};
			{iconName="vehicleSales",intern=true,view=false,name="vehicleSalesSlot_",typ="slot",autoClose=true, onAction=moSetGetLight.onActionSlot, onDrawColorState=moSetGetLight.onDrawColorStateSlotPda};
			{iconName="windTurbines",intern=true,view=false,name="windTurbinesSlot_",typ="slot",autoClose=true, onAction=moSetGetLight.onActionSlot, onDrawColorState=moSetGetLight.onDrawColorStateSlotPda};
			{iconName="solarpanels",intern=true,view=false,name="solarpanelsSlot_",typ="slot",autoClose=true, onAction=moSetGetLight.onActionSlot, onDrawColorState=moSetGetLight.onDrawColorStateSlotPda};
			{iconName="mapFieldsInfo",intern=true,view=false,name="mapFieldsInfoSlot_",typ="slot",autoClose=true, onAction=moSetGetLight.onActionSlot, onDrawColorState=moSetGetLight.onDrawColorStateSlotPda};
			{iconName="beehives",intern=true,view=false,name="beehivesSlot_",typ="slot",autoClose=true, onAction=moSetGetLight.onActionSlot, onDrawColorState=moSetGetLight.onDrawColorStateSlotPda};
			{iconName="chargingStations",intern=true,view=false,name="chargingStationsSlot_",typ="slot",autoClose=true, onAction=moSetGetLight.onActionSlot, onDrawColorState=moSetGetLight.onDrawColorStateSlotPda};
			{iconName="handToolsSwitch",intern=true,view=false,name="MultiOverlayV4_cmd_action_handToolsSwitch_",typ="cmd",iconText={onDraw=moDraw.iconText.setPdaTxt}, onAction=moSetGetLight.onActionCmd}; 
			{iconName="switchPdas",intern=true,view=false,name="MultiOverlayV4_cmd_action_switchPdas_",typ="cmd", onAction=moSetGetLight.onActionCmd};
			{iconName="switchSlots",intern=true,view=false,name="MultiOverlayV4_cmd_action_switchSlots_",typ="cmd", onAction=moSetGetLight.onActionCmd};
			{iconName="switchProfile",intern=true,view=false,name="MultiOverlayV4_cmd_action_switchProfile_",typ="cmd", onAction=moSetGetLight.onActionCmd};
			{iconName="animals",intern=true,view=true,name="animalsSlot_",typ="slot",autoClose=true, onAction=moSetGetLight.onActionSlot, onDrawColorState=moSetGetLight.onDrawColorStateSlotPda};
		};
		appIcon = {};
		appIconView = {};
		icon = {};	
	};
	pdaMod = {
		name = "";
		view = {true,false}; --view / smallView --free
		minViewApps=2; --not edit
		maxViewApps=20;
		autoWidth=true;
		bounds={isLine=1,line={},lineMax=1,maxViewApps=0,viewApps=0};		
		selectApp=1;
		otherIcons = 2;
		distancePda = 4; --..../distancePda
		appOrder = {};	
		app = {};
		appIcon = {};
		appIconView = {};
		icon = {};
	};
	pda = {};	
	lsWtmBox = {};	
};

function moSetGetOverlaysLight:generate()		
	g_currentMission.multiOverlayV4.moSetGetOverlaysLight = moSetGetOverlaysLight;
	moSetGetOverlaysLight.default.lsWtmBox = {g_currentMission.hl.getOverlay(g_currentMission.hud.gameInfoDisplay.backgroundOverlay.overlay)};	
	local height = 1.00-(moSetGetOverlaysLight.default.lsWtmBox[2]+moSetGetOverlaysLight.default.lsWtmBox[4])+0.0015;	
	--calculate width/height			
	local int = 0;
	while moSetGetOverlays.buttonGfxHeight1*int <= height do			
		int = int+1
	end;
	local h = (moSetGetOverlays.buttonGfxHeight1*int)/4; --other
	local w = (moSetGetOverlays.buttonGfxWidth1*int)/4; --other		
	moSetGetOverlaysLight.default.appHeight = moSetGetOverlays.buttonGfxHeight1*(int/1.3); --h*3
	moSetGetOverlaysLight.default.appWidth = moSetGetOverlays.buttonGfxWidth1*(int/1.3); --w*3
	moSetGetOverlaysLight.default.iconHeight = moSetGetOverlaysLight.default.appHeight/2; --h
	moSetGetOverlaysLight.default.iconWidth = moSetGetOverlaysLight.default.appWidth/2; --w
	moSetGetOverlaysLight.default.optiHeightSize = g_currentMission.hl.optiHeightSize(moSetGetOverlaysLight.default.iconHeight, "Ä", 0.015);
	--calculate width/height	
		
	local iconHeight = moSetGetOverlaysLight.default.iconHeight;	
	local iconWidth = moSetGetOverlaysLight.default.iconWidth;	
	
	local iconFilePath = Utils.getFilename("icons/settings.dds", MultiOverlayV4.modDir);
	---------setting---------
	--ground--
	moSetGetOverlaysLight.default.setting.icon.background = Overlay.new(g_baseUIFilename, 0, 0, 0, 0);
	moSetGetOverlaysLight.default.setting.icon.background:setUVs(g_colorBgUVs);
	moSetGetOverlaysLight.default.setting.icon.background:setColor(0, 0, 0, 0.8);
	moSetGetOverlaysLight.default.setting.icon.backgroundApp = Overlay.new(g_baseUIFilename, 0, 0, 0, 0);
	moSetGetOverlaysLight.default.setting.icon.backgroundApp:setUVs(g_colorBgUVs);
	moSetGetOverlaysLight.default.setting.icon.backgroundApp:setColor(0, 0, 0, 0.8);
	--ground--
	--buttonLeftRight--
	moSetGetOverlaysLight.default.setting.icon.buttonLeftRight = Overlay.new(iconFilePath, 0, 0, iconWidth, iconHeight); 
	g_currentMission.hl.setOverlayUVsPx(moSetGetOverlaysLight.default.setting.icon.buttonLeftRight, unpack(g_currentMission.hl.getNormalUVs(0, 0, 0, 39)));
	g_currentMission.hl.setBackgroundColor(moSetGetOverlaysLight.default.setting.icon.buttonLeftRight, g_currentMission.hl.getColor(moSetGetOverlaysLight.default.iconColor.default, true));
	--buttonLeftRight--	
	--buttonAutoClose--
	moSetGetOverlaysLight.default.setting.icon.buttonAutoClose = Overlay.new(iconFilePath, 0, 0, iconWidth, iconHeight); 
	g_currentMission.hl.setOverlayUVsPx(moSetGetOverlaysLight.default.setting.icon.buttonAutoClose, unpack(g_currentMission.hl.getNormalUVs(0, 0, 0, 46)));	
	--buttonAutoClose--
	--buttonInofBar--
	moSetGetOverlaysLight.default.setting.icon.buttonInfoBar = Overlay.new(iconFilePath, 0, 0, iconWidth, iconHeight); 
	g_currentMission.hl.setOverlayUVsPx(moSetGetOverlaysLight.default.setting.icon.buttonInfoBar, unpack(g_currentMission.hl.getNormalUVs(0, 0, 0, 32)));	
	--buttonInfoBar--
	--buttonView--
	moSetGetOverlaysLight.default.setting.icon.buttonView = Overlay.new(iconFilePath, 0, 0, iconWidth, iconHeight); 
	g_currentMission.hl.setOverlayUVsPx(moSetGetOverlaysLight.default.setting.icon.buttonView, unpack(g_currentMission.hl.getNormalUVs(0, 0, 0, 35)));
	--buttonView--
	--appSelect--
	moSetGetOverlaysLight.default.setting.icon.appSelect = Overlay.new(iconFilePath, 0, 0, moSetGetOverlaysLight.default.appWidth, 0.012); 
	g_currentMission.hl.setOverlayUVsPx(moSetGetOverlaysLight.default.setting.icon.appSelect, unpack(g_currentMission.hl.getNormalUVs(0, 0, 0, 32)));
	g_currentMission.hl.setBackgroundColor(moSetGetOverlaysLight.default.setting.icon.appSelect, g_currentMission.hl.getColor("deepPink", true));
	--appSelect--
	--buttonSave--
	moSetGetOverlaysLight.default.setting.icon.buttonSave = Overlay.new(iconFilePath, 0, 0, iconWidth, iconHeight); 
	g_currentMission.hl.setOverlayUVsPx(moSetGetOverlaysLight.default.setting.icon.buttonSave, unpack(g_currentMission.hl.getNormalUVs(0, 0, 0, 17)));
	g_currentMission.hl.setBackgroundColor(moSetGetOverlaysLight.default.setting.icon.buttonSave, g_currentMission.hl.getColor("green", true));
	--buttonSave--
	--buttonClose--
	moSetGetOverlaysLight.default.setting.icon.buttonClose = Overlay.new(iconFilePath, 0, 0, iconWidth, iconHeight); 
	g_currentMission.hl.setOverlayUVsPx(moSetGetOverlaysLight.default.setting.icon.buttonClose, unpack(g_currentMission.hl.getNormalUVs(0, 0, 0, 2)));
	g_currentMission.hl.setBackgroundColor(moSetGetOverlaysLight.default.setting.icon.buttonClose, g_currentMission.hl.getColor("red", true));
	--buttonClose--
	--buttonDelete--
	moSetGetOverlaysLight.default.setting.icon.buttonDelete = Overlay.new(iconFilePath, 0, 0, iconWidth, iconHeight); 
	g_currentMission.hl.setOverlayUVsPx(moSetGetOverlaysLight.default.setting.icon.buttonDelete, unpack(g_currentMission.hl.getNormalUVs(0, 0, 0, 29)));
	g_currentMission.hl.setBackgroundColor(moSetGetOverlaysLight.default.setting.icon.buttonDelete, g_currentMission.hl.getColor("yellow", true));
	--buttonDelete--
	--buttonOnOff--
	moSetGetOverlaysLight.default.setting.icon.buttonOnOff = Overlay.new(iconFilePath, 0, 0, iconWidth, iconHeight); 
	g_currentMission.hl.setOverlayUVsPx(moSetGetOverlaysLight.default.setting.icon.buttonOnOff, unpack(g_currentMission.hl.getNormalUVs(0, 0, 0, 47)));
	g_currentMission.hl.setBackgroundColor(moSetGetOverlaysLight.default.setting.icon.buttonOnOff, g_currentMission.hl.getColor("red", true));
	--buttonOnOff--	
	---------setting---------
	---------appIcons--------
	moSetGetOverlays:loadIcons( {xmlTagName="pdaTypeLight.appIcons", modDir=MultiOverlayV4.modDir, iconFile="icons/pdaTypeLight.dds", xmlFile="icons/pdaTypeLight.xml", modName="MultiOverlayV4", groupName="pdaTypeLight", fileFormat="m512x512"} );
	---------appIcons--------	
	
	--set app order default--
	for app=1, #moSetGetOverlaysLight.default.pdaDefault.app do
		moSetGetOverlaysLight.default.pdaDefault.appOrder[moSetGetOverlaysLight.default.pdaDefault.app[app].iconName] = app;
	end;
	--set app order default--
		
	--moSetGetOverlaysLight:generatePda(1);
	--moSetGetOverlaysLight:generatePda(2);
end;

function moSetGetOverlaysLight:generatePdaOverXml(pda)
	moSetGetOverlaysLight.default.pda[pda] = g_currentMission.hl.getTableCopy(moSetGetOverlaysLight.default.pdaDefault);moSetGetOverlaysLight.default.pda[pda].appOrder = {};moSetGetOverlaysLight.default.pda[pda].appIcon = {};moSetGetOverlaysLight.default.pda[pda].icon = {};moSetGetOverlaysLight.default.pda[pda].app = {};
end;

function moSetGetOverlaysLight:generatePda(pda, overXml)
	if pda == nil or (overXml == nil and moSetGetOverlaysLight.default.pda[pda] ~= nil) then return;end;
	if moSetGetOverlaysLight.default.pda[pda] == nil then moSetGetOverlaysLight.default.pda[pda] = g_currentMission.hl.getTableCopy(moSetGetOverlaysLight.default.pdaDefault);moSetGetOverlaysLight.default.pda[pda].appOrder = {};moSetGetOverlaysLight.default.pda[pda].appIcon = {};moSetGetOverlaysLight.default.pda[pda].icon = {};end;
	local height = 1.00-(moSetGetOverlaysLight.default.lsWtmBox[2]+moSetGetOverlaysLight.default.lsWtmBox[4])+0.0015;
	local iconHeight = moSetGetOverlaysLight.default.iconHeight;	
	local iconWidth = moSetGetOverlaysLight.default.iconWidth;
	local iconSmallWidth = iconWidth/1.2;
	local iconSmallHeight = iconHeight/1.2;
	---------pda default icons---------
	--ground--
	if pda == 1 then
		moSetGetOverlaysLight.default.pda[pda].icon.background = Overlay.new(g_baseUIFilename, moSetGetOverlaysLight.default.lsWtmBox[1], moSetGetOverlaysLight.default.lsWtmBox[2]+moSetGetOverlaysLight.default.lsWtmBox[4]+0.0005, moSetGetOverlaysLight.default.lsWtmBox[3], height);
		moSetGetOverlaysLight.default.pda[pda].name = "masterPda_"; 
	else
		moSetGetOverlaysLight.default.pda[pda].autoWidth = false;
		moSetGetOverlaysLight.default.pda[pda].minViewApps = 4;
		moSetGetOverlaysLight.default.pda[pda].name = "slavePda".. tostring(pda).. "_";	
		local width = moSetGetOverlaysLight:getPdaWidth(pda);
		local prePdaTable = moSetGetOverlaysLight.default.pda[pda-1];
		local tempPosX = prePdaTable.icon.background.x-width-(iconWidth/moSetGetOverlaysLight.default.pda[pda].distancePda);
		moSetGetOverlaysLight.default.pda[pda].icon.background = Overlay.new(g_baseUIFilename, tempPosX, prePdaTable.icon.background.y, width, prePdaTable.icon.background.height);			
	end;
	moSetGetOverlaysLight.default.pda[pda].icon.background:setUVs(g_colorBgUVs);
	moSetGetOverlaysLight.default.pda[pda].icon.background:setColor(0, 0, 0, 0.75);
	local overlay = moSetGetOverlaysLight.default.pda[pda].icon.background;
	--ground--	
	local iconFilePath = Utils.getFilename("icons/pdaTypeLight.dds", MultiOverlayV4.modDir);
	--buttonSetting--	
	moSetGetOverlaysLight.default.pda[pda].icon.buttonSetting = Overlay.new(iconFilePath, (overlay.x+overlay.width)-(iconWidth), overlay.y+(overlay.height/2)-(iconHeight/2), iconWidth, iconHeight);
	g_currentMission.hl.setOverlayUVsPx(moSetGetOverlaysLight.default.pda[pda].icon.buttonSetting, unpack(g_currentMission.hl.getNormalUVs(0, 0, 0, 63)));
	--g_currentMission.hl.setBackgroundColor(moSetGetOverlaysLight.default.pda[pda].icon.buttonSetting, g_currentMission.hl.getColor("ls22", true));
	--buttonSetting--
	iconFilePath = Utils.getFilename("icons/settings.dds", MultiOverlayV4.modDir);
	--buttonLeft--	
	moSetGetOverlaysLight.default.pda[pda].icon.buttonLeft = Overlay.new(iconFilePath, overlay.x, overlay.y+(overlay.height/2)-(iconHeight/2), iconWidth, iconHeight); 
	g_currentMission.hl.setOverlayUVsPx(moSetGetOverlaysLight.default.pda[pda].icon.buttonLeft, unpack(g_currentMission.hl.getNormalUVs(0, 0, 0, 4)));	
	--g_currentMission.hl.setBackgroundColor(moSetGetOverlaysLight.default.pda[pda].icon.buttonLeft, g_currentMission.hl.getColor("ls22", true));
	--buttonLeft--	
	--appInfoBar--
	moSetGetOverlaysLight.default.pda[pda].icon.appInfoBar = Overlay.new(iconFilePath, 0, (overlay.y+overlay.height)-0.012, moSetGetOverlaysLight.default.appWidth, 0.015); 
	g_currentMission.hl.setOverlayUVsPx(moSetGetOverlaysLight.default.pda[pda].icon.appInfoBar, unpack(g_currentMission.hl.getNormalUVs(0, 0, 0, 32)));
	g_currentMission.hl.setBackgroundColor(moSetGetOverlaysLight.default.pda[pda].icon.appInfoBar, g_currentMission.hl.getColor(moSetGetOverlaysLight.default.iconColor.infoBar, true));
	moSetGetOverlaysLight.default.pda[pda].icon.appInfoBarProzent = Overlay.new(iconFilePath, 0, (overlay.y+overlay.height)-0.012, 0, 0.015); 
	g_currentMission.hl.setOverlayUVsPx(moSetGetOverlaysLight.default.pda[pda].icon.appInfoBarProzent, unpack(g_currentMission.hl.getNormalUVs(0, 0, 0, 32)));
	g_currentMission.hl.setBackgroundColor(moSetGetOverlaysLight.default.pda[pda].icon.appInfoBarProzent, g_currentMission.hl.getColor(moSetGetOverlaysLight.default.iconColor.default, true));
	--appInfoBar--
	--appNotice--
	moSetGetOverlaysLight.default.pda[pda].icon.appNotice = Overlay.new(iconFilePath, 0, moSetGetOverlaysLight.default.pda[pda].icon.appInfoBar.y-(iconHeight/3), iconWidth, iconHeight); --oben rechts/mitte
	--moSetGetOverlaysLight.default.pda[pda].icon.appNotice = Overlay.new(iconFilePath, 0, overlay.y-0.005, iconWidth, iconHeight); --unten mitte
	g_currentMission.hl.setOverlayUVsPx(moSetGetOverlaysLight.default.pda[pda].icon.appNotice, unpack(g_currentMission.hl.getNormalUVs(0, 0, 0, 47)));
	g_currentMission.hl.setBackgroundColor(moSetGetOverlaysLight.default.pda[pda].icon.appNotice, g_currentMission.hl.getColor(moSetGetOverlaysLight.default.iconColor.notice, true));
	--appNotice--
	--appSelect--
	moSetGetOverlaysLight.default.pda[pda].icon.appSelect = Overlay.new(iconFilePath, 0, overlay.y-0.005, moSetGetOverlaysLight.default.appWidth, 0.012); 
	g_currentMission.hl.setOverlayUVsPx(moSetGetOverlaysLight.default.pda[pda].icon.appSelect, unpack(g_currentMission.hl.getNormalUVs(0, 0, 0, 32)));
	g_currentMission.hl.setBackgroundColor(moSetGetOverlaysLight.default.pda[pda].icon.appSelect, g_currentMission.hl.getColor("deepPink", true));
	--appSelect--
	---------pda default icons---------
	---------pda app icons---------
	iconFilePath = Utils.getFilename("icons/pdaTypeLight.dds", MultiOverlayV4.modDir);
	local loadAppTable = moSetGetOverlaysLight.default.pdaDefault.app;
	if overXml ~= nil and overXml then loadAppTable = moSetGetOverlaysLight.default.pda[pda].app;end;
	for app=1, #loadAppTable do
		local iconName = loadAppTable[app].iconName;
		local defaultAppIcon = nil;
		local iconPos = moSetGetOverlays.icons.byName["MultiOverlayV4"]["pdaTypeLight"][iconName];
		if iconPos ~= nil then defaultAppIcon = moSetGetOverlays.icons["MultiOverlayV4"]["pdaTypeLight"][iconPos];end;
		local appIcon = nil;
		if defaultAppIcon ~= nil then 
			local saveArgsNew = g_currentMission.hl.getTableCopy(defaultAppIcon.saveArgs);
			saveArgsNew.loadIcons={defaultAppIcon.iconPlace};
			saveArgsNew.otherTable = moSetGetOverlaysLight.default.pda[pda].appIcon;
			local firstIcon, endIcon = moSetGetOverlays:loadIcons(saveArgsNew);
			--if firstIcon ~= nil then
				appIcon = moSetGetOverlaysLight.default.pda[pda].appIcon[firstIcon];
				g_currentMission.hl.setOverlay(appIcon, 0, overlay.y, moSetGetOverlaysLight.default.appWidth, moSetGetOverlaysLight.default.appHeight);
			--end;
		else
			moSetGetOverlaysLight.default.pda[pda].appIcon[#moSetGetOverlaysLight.default.pda[pda].appIcon+1] = Overlay.new(iconFilePath, 0, overlay.y, moSetGetOverlaysLight.default.appWidth, moSetGetOverlaysLight.default.appHeight);
			appIcon = moSetGetOverlaysLight.default.pda[pda].appIcon[#moSetGetOverlaysLight.default.pda[pda].appIcon];
			g_currentMission.hl.setOverlayUVsPx(appIcon, unpack(g_currentMission.hl.getNormalUVs(0, 0, 0, 64))); --default Fail Icon
		end;
		if appIcon ~= nil then
			appIcon.view = loadAppTable[app].view or false;
		end;
	end;	
	---------pda app icons---------	
	moSetGetLight:setPdaBounds(pda);
end;

function moSetGetOverlaysLight:deleteSlavePda(pda)
	moSetGetOverlaysLight.default.setting.on = false;
	moSetGetOverlaysLight.default.setting.selectApp = 0;
	moSetGetOverlaysLight.default.setting.selectPda = 0;
	moSetGetOverlaysLight.default.pda[pda].view[1] = false;
	g_currentMission.hl.deleteOverlays(moSetGetOverlaysLight.default.pda[pda].appIcon);
	g_currentMission.hl.deleteOverlays(moSetGetOverlaysLight.default.pda[pda].icon);
	table.remove(moSetGetOverlaysLight.default.pda, pda);
	moSetGetPdaTypeLightXML:saveConfig("pdaTypeLightXML");
	moSetGetOverlaysLight:updateSlavePdas();
end;

function moSetGetOverlaysLight:deletePdaTypeLightIcons()
	if moSetGetOverlaysLight.default.pda ~= nil and #moSetGetOverlaysLight.default.pda > 0 then								
		for a=1, #moSetGetOverlaysLight.default.pda do
			g_currentMission.hl.deleteOverlays(moSetGetOverlaysLight.default.pda[a].appIcon);
			g_currentMission.hl.deleteOverlays(moSetGetOverlaysLight.default.pda[a].icon);
		end;		
	end;
	if moSetGetOverlaysLight.default.setting.icon ~= nil then
		g_currentMission.hl.deleteOverlays(moSetGetOverlaysLight.default.setting.icon);		
		moSetGetOverlaysLight.default.setting.icon = {};
	end;
end;

function moSetGetOverlaysLight:loadAppIconChange(pda, app)
	
	
end;

function moSetGetOverlaysLight:updateSlavePdas()
	if #moSetGetOverlaysLight.default.pda < 2 then return;end;
	for pda=2, #moSetGetOverlaysLight.default.pda do
		local boxPosX = moSetGetOverlaysLight.default.pda[pda-1].icon.background.x;		
		local pdaWidth = moSetGetOverlaysLight:getPdaWidth(pda);
		local sollPosX = boxPosX-pdaWidth-(moSetGetOverlaysLight.default.iconWidth/moSetGetOverlaysLight.default.pda[pda].distancePda);		
		if sollPosX ~= moSetGetOverlaysLight.default.pda[pda].icon.background.x or moSetGetOverlaysLight.default.pda[pda].icon.background.width ~= pdaWidth then
			g_currentMission.hl.setOverlay(moSetGetOverlaysLight.default.pda[pda].icon.background, sollPosX, nil, pdaWidth);			
		end;
	end;
end;

function moSetGetOverlaysLight:updateMasterPda()
	if moSetGetOverlaysLight.default.pda[1] == nil then return false;end;
	local resetBounds = false;
	local pdaWidth = moSetGetOverlaysLight:getPdaWidth(1);
	local boxWidth = moSetGetOverlaysLight.default.lsWtmBox[3];
	local boxPosX = moSetGetOverlaysLight.default.lsWtmBox[1];
	local pdaPosX = moSetGetOverlaysLight:getPdaPosX(1);
	local lightAutoWidthFirstStart = moGeneralSettings.pdaType.lightAutoWidthFirstStart;
	function minView()
		if pdaPosX ~= moSetGetOverlaysLight.default.pda[1].icon.background.x or lightAutoWidthFirstStart then
			g_currentMission.hl.setOverlay(moSetGetOverlaysLight.default.pda[1].icon.background, pdaPosX, nil, pdaWidth);			
			resetBounds = true;
		end;
		moGeneralSettings.pdaType.lightAutoWidthFirstStart = false;
	end;
	if moSetGetOverlaysLight.default.pda[1].autoWidth then	
		if pdaPosX ~= moSetGetOverlaysLight.default.lsWtmBox[1] or boxWidth ~= moSetGetOverlaysLight.default.pda[1].icon.background.width or pdaPosX+pdaWidth < 0.99 or lightAutoWidthFirstStart then
			if boxWidth < pdaWidth then
				boxWidth = pdaWidth;
			end;
			if boxPosX+pdaWidth > 1 then 
				minView();
			else
				if moSetGetOverlaysLight.default.pda[1].icon.background.width ~= boxWidth or pdaPosX+pdaWidth < 0.99 or lightAutoWidthFirstStart then			
					g_currentMission.hl.setOverlay(moSetGetOverlaysLight.default.pda[1].icon.background, boxPosX, nil, boxWidth);					
					resetBounds = true;
				end;
			end;
			moGeneralSettings.pdaType.lightAutoWidthFirstStart = false;
		end;
	else
		minView();
	end;	
	if resetBounds then moSetGetLight:setPdaBounds(1);end;
	return resetBounds;
end;

function moSetGetOverlaysLight:update(dt)
	if not moGeneralSettings.pdaType.light then return;end;
	moSetGetOverlaysLight.default.lsWtmBox = {g_currentMission.hl.getOverlay(g_currentMission.hud.gameInfoDisplay.backgroundOverlay.overlay)};
	local isReset = moSetGetOverlaysLight:updateMasterPda();
	if isReset then moSetGetOverlaysLight:updateSlavePdas();end;
end;

function moSetGetOverlaysLight:getPdaMaxViewApps(pda)	
	local pdaTable = moSetGetOverlaysLight.default.pda[pda];
	local width = pdaTable.icon.background.width-(moSetGetOverlaysLight.default.iconWidth*pdaTable.otherIcons);
	local roundUp = false;
	if pda > 1 then roundUp = true;end;
	local maxViewApps = g_currentMission.hl.getMaxIconWidth(width, moSetGetOverlaysLight.default.appWidth, roundUp);	
	if maxViewApps < moSetGetOverlaysLight.default.limitMinViewApps then maxViewApps = moSetGetOverlaysLight.default.limitMinViewApps;end;
	if maxViewApps > moSetGetOverlaysLight.default.limitMaxViewApps then maxViewApps = moSetGetOverlaysLight.default.limitMaxViewApps;end;
	return maxViewApps;	
end;

function moSetGetOverlaysLight:getPdaWidth(pda)
	local pdaTable = moSetGetOverlaysLight.default.pda[pda];	
	if not pdaTable.autoWidth then
		return (moSetGetOverlaysLight.default.appWidth*pdaTable.minViewApps)+(moSetGetOverlaysLight.default.iconWidth*pdaTable.otherIcons);
	end;
	return (moSetGetOverlaysLight.default.appWidth*moSetGetOverlaysLight.default.limitMinViewApps)+(moSetGetOverlaysLight.default.iconWidth*pdaTable.otherIcons);
end;

function moSetGetOverlaysLight:getPdaPosX(pda)
	local pdaTable = moSetGetOverlaysLight.default.pda[pda];
	if pda == 1 or pda == nil then
		return 1.00 - moSetGetOverlaysLight:getPdaWidth(1);
	end;	
end;

function moSetGetOverlaysLight:searchMohOverlapHuds(profileSwitch)		
	local nextX = 0.6;
	local nextY = 0.85;		
	local pdas = moSetGetPda:getPdas();
	if #pdas > 0 then
		if profileSwitch ~= nil and profileSwitch then
			moSetGet:setWtmState("ShowMoney", true, false);
			moSetGet:setWtmState("ShowWeather", true, false);		
		end;
		for a=1, #moSetGetOverlaysLight.default.pda do
			local x1, y1, w1, h1 = g_currentMission.hl.getOverlay(moSetGetOverlaysLight.default.pda[a].icon.background)
			for pda=1, #pdas do
				local pdaTable = moSetGetOverlays.pda[pdas[pda]];
				if pdaTable ~= nil then
					local x2 = pdaTable.posX[pdaTable.view.isModus];
					local y2 = pdaTable.posY[pdaTable.view.isModus];
					local w2 = pdaTable.width[pdaTable.view.isModus];
					local h2 = pdaTable.height[pdaTable.view.isModus];						
					if g_currentMission.hl.overlayOverlap({x=x1,y=y1,width=w1,height=h1}, {x=x2,y=y2,width=w2,height=h2}) then
						pdaTable.posX[pdaTable.view.isModus] = nextX;
						pdaTable.posY[pdaTable.view.isModus] = nextY-h2;				
						nextY = nextY-(h2*2)-0.001;
						moSetGetOverlays:refreshAppIconFormatTxt(pdas[pda]);
						if pdaTable.posX[pdaTable.view.isModus]+pdaTable.width[pdaTable.view.isModus] > 1 then
							pdaTable.width[pdaTable.view.isModus] = moSetGetPda.default.width.default;
							moSetGetPda:resetSettingLinesBounds(pdas[pda]);
							moSetGetPda:resetLineAppBounds(pdas[pda]);
						end;
						MultiOverlayV4:setUnSave();
					end;					
				end;
			end;
		end;		
	end;		
end;





